﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: phil
 * Dátum: 2011.07.13.
 * Idő: 14:10
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Drawing;

namespace TetheredSun.Controls
{
	/// <summary>
	/// Description of ErrorBar.
	/// </summary>
	public class ErrorBar
	{
		protected Pen line;
		protected float baseWidth;
		
		public ErrorBar(Pen lineBase, float baseWidth)
		{
			this.line = (Pen)lineBase.Clone();
			this.baseWidth = baseWidth;
		}
		
		public ErrorBar(Pen lineBase) : this(lineBase, 7.0f) { }
		
		
		public float BaseWidth {
			get { return baseWidth; }
			set { baseWidth = value; }
		}
		
		public Pen Line {
			get { return line; }
		}
		
		internal void Draw(Graphics graphics, PointF centre, float size)
		{
			float x1;
			float y1;
			float x2;
			float y2;
			float w = baseWidth / 2.0f;
			float h = size / 2.0f;
			
			// Draw upper base:
			x1 = centre.X - w;
			y1 = centre.Y - h;
			x2 = centre.X + w;
			y2 = y1;
			graphics.DrawLine(line, x1, y1, x2, y2);
			
			// Draw the bar itself:
			x1 = centre.X;
			y1 = centre.Y - h;
			x2 = x1;
			y2 = centre.Y + h;
			graphics.DrawLine(line, x1, y1, x2, y2);
			
			// Draw lower base:
			x1 = centre.X - w;
			y1 = centre.Y + h;
			x2 = centre.X + w;
			y2 = y1;
			graphics.DrawLine(line, x1, y1, x2, y2);
		}
	}
}
