﻿/*
 * Készítette a SharpDevelop.
 * Felhasználó: phil
 * Dátum: 2011.07.20.
 * Idő: 12:06
 * 
 * A sablon megváltoztatásához használja az Eszközök | Beállítások | Kódolás | Szabvány Fejlécek Szerkesztését.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
//
using TetheredSun;

namespace TetheredSun.Controls
{
	/// <summary>
	/// Description of ProbeForm.
	/// </summary>
	public partial class ProbeForm : Form
	{
		public ProbeForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			noiseGraph.Curves.Add(new Curve());
		}
		
		
		public NoiseGraph NoiseGraph {
			get { return noiseGraph; }
		}
		
		
		public void Show(double[] x, double[] y, bool modal)
		{
			noiseGraph.Curves[0].Points.Clear();
			noiseGraph.Curves[0].Points.SetItems(x, y);
			noiseGraph.Refresh();
			
			if (modal) {
				this.ShowDialog();
			} else {
				this.Show();
			}
		}
		
		public void Show(IList<Point<double>> points, bool modal)
		{
			noiseGraph.Curves[0].Points.Clear();
			
			for (int i = 0; i < points.Count; i++) {
				noiseGraph.Curves[0].Points.Add(points[i]);
			}
			
			noiseGraph.Refresh();
			
			if (modal) {
				this.ShowDialog();
			} else {
				this.Show();
			}
		}
		
		public void Show(double[] y, bool modal)
		{
			noiseGraph.Curves[0].Points.Clear();
			
			for (int i = 0; i < y.Length; i++) {
				noiseGraph.Curves[0].Points.Add(i, y[i]);
			}
			
			noiseGraph.Refresh();
			
			if (modal) {
				this.ShowDialog();
			} else {
				this.Show();
			}
		}
		
		public void Show(double[] y, double x0, double dx, bool modal)
		{
			noiseGraph.Curves[0].Points.Clear();
			
			for (int i = 0; i < y.Length; i++) {
				noiseGraph.Curves[0].Points.Add(x0 + i * dx, y[i]);
			}
			
			noiseGraph.Refresh();
			
			if (modal) {
				this.ShowDialog();
			} else {
				this.Show();
			}
		}
	}
}
