﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2011.01.03.
 * Time: 15:46
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
//
using TetheredSun.Mathematics;

namespace TetheredSun.Medical
{
	/// <summary>
	/// Description of LongTermVariability.
	/// </summary>
	public class LongTermVariability : SequenceParameter
	{
		public LongTermVariability(string unit)
		{
			this.unit = unit;
			this.name = "Long-term variability";
			this.value = Double.NaN;
		}
		
		public LongTermVariability() : this("s") { }
		
		public override double Evaluate(IList<double> intervals)
		{
			int n = intervals.Count;
			double sum = 0.0;
			double mean = intervals.GetMean();
			
			for (int i = 1; i < n; i++) {
				sum += Math.Abs(intervals[i] + intervals[i - 1] - 2.0 * mean);
			}
			
			value = sum / (Math.Sqrt(2.0) * n);
			return value;
		}
	}
}
