﻿/*
 * Created by SharpDevelop.
 * User: phil
 * Date: 2010.12.30.
 * Time: 14:31
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace TetheredSun.Medical
{
	/// <summary>
	/// Description of SequenceParameter.
	/// </summary>
	public abstract class SequenceParameter
	{
		protected double value;
		protected string name;
		protected string unit;		
		
		public double Value {
			get { return value; }
		}
		
		public string Name {
			get { return name; }
			set { name = value; }
		}
		
		public static List<SequenceParameter> StandardParameters {
			get {
				return new List<SequenceParameter>(new SequenceParameter[] {
					                            	new IntervalMean(),
					                            	new IntervalSD(),
					                            	new IntervalRms(),
					                            	new SuccessiveDifferenceSD(),
					                            	new SuccessiveDifferenceRms(),
					                            	new Pnn50(),
					                            	new ShortTermVariability(),
					                            	new LongTermVariability(),
					                            	new Instability()
					                            });
			}
		}
		
		public string Unit {
			get { return unit; }
		}
		
		public abstract double Evaluate(IList<double> intervals);
		
		
		public string ToString(string format)
		{
			return String.Format("{0}: {1} {2}", name, value.ToString(format), unit);
		}
		
		public string ToCsvString(string format, string separator)
		{
			return String.Format("{0} [{1}]{2}{3}", name, unit, separator, value.ToString(format));
		}
	}
}
